/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/stdint.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

/*
 * @(#)B.11.31_LR
 */

#ifndef _STDINT_INCLUDED
#define _STDINT_INCLUDED

#ifndef _SYS_STDSYMS_INCLUDED
#  include <sys/stdsyms.h>
#endif /* _SYS_STDSYMS_INCLUDED */

#ifndef _SYS__INTTYPES_INCLUDED
#  include <sys/_inttypes.h>
#endif /* _SYS__INTTYPES_INCLUDED */

/* ************************ CONSTANTS ********************************
**
** The following macros create constants of the integer types. The intent is
** that:
**	Constants defined using these macros have a specific length and
**	signedness. 
**
*/
/* handle ANSI C, aC++ and C++ with -Aa */
#if defined(__STDC__) || __cplusplus >= 199707L || defined(__STDCPP__)
#  define __CONCAT__(_A,_B) _A ## _B
#  define __CONCAT_U__(_A) _A ## u
/*
 * handle C -Ae and aC++ & C++ with -ext 
 * LP64 takes precedence 
 */
#  if defined(__LL_MODE__) && !defined(__L64_MODE__)
#    define __CONCAT_L__(_A,_B) _A ## _B ## l        /* extra l for long long  */
#  else
#    define __CONCAT_L__(_A,_B) _A ## _B
#  endif  
#else   /* K&R cpp */
#  define __CONCAT__(_A,_B) _A/**/_B
#  ifdef __cplusplus
#    define __CONCAT_U__(_A) _A/**/u
#  else
#    define __CONCAT_U__(_A) _A                      /* K&R C does not support u */
#  endif
#  define __CONCAT_L__(_A,_B) _A/**/_B/**/l
#endif /* __STDC__ || __cplusplus >= 199707L || __STDCPP__ */

#if defined(_INCLUDE_STDC__SOURCE_199901) || (  defined(__cplusplus) && defined(__STDC_CONSTANT_MACROS) ) 
#define INT8_C(__c) 			 (__c) 
#define UINT8_C(__c) (__c)

#define INT16_C(__c)			 (__c) 
#define UINT16_C(__c) (__c)

#ifdef __LP64__
#define INT32_C(__c)			 (__c)
#define UINT32_C(__c) __CONCAT__(__c,u)
#else /* __LP64 */
#define INT32_C(__c) (__c)
#define UINT32_C(__c) __CONCAT__(__c,u)
#endif /* __LP64 */

#if !defined(__STDC_32_MODE__)
#define INT64_C(__c) 			 __CONCAT_L__(__c,l) 
#define UINT64_C(__c)			 __CONCAT_L__(__c,ul)
#endif

#define INTMAX_C(__c)			 __CONCAT_L__(__c,l)
#define UINTMAX_C(__c)			 __CONCAT_L__(__c,ul)

#endif /* (_INCLUDE_STDC__SOURCE_199901) || ( (__cplusplus) && (__STDC_CONSTANT_MACROS) ) */

/* ************************** limits ***********************************
**
** The following defines the limits for the integer types.
**
** INTMAX_MIN (minimum value of the largest supported integer type),
** INTMAX_MAX (maximum value of the largest supported integer type),
** and UINTMAX_MAX (maximum value of the largest supported unsigned integer
** type) can be set to implementation defined limits. 
**
** NOTE : A programmer can test to see whether an implementation supports
** a particular size of integer by testing if the macro that gives the
** maximum for that datatype is defined. For example, if #ifdef UINT64_MAX
** tests false, the implementation does not support unsigned 64 bit integers.
**
** The values used below are merely examples using the 2's complement
** numbering system. Actual limits for an implementation may vary.
**
** Following macros should appear for C99 or for C++ only when 
   __STDC_LIMIT_MACROS is defined before entering stdint.h
   These macros should be usable in #if constructs, hence,
   should not contain casts. These are implementation dependent
   values.
*/

#if defined(_INCLUDE_STDC__SOURCE_199901) || (  defined(__cplusplus) && defined(__STDC_LIMIT_MACROS) ) 
#define INT8_MAX       INT8_C(127)
#define INT16_MAX      INT16_C(32767)
#define INT32_MAX      INT32_C(2147483647)
#if !defined(__STDC_32_MODE__)
#define INT64_MAX INT64_C(9223372036854775807) 
#endif

#define INT8_MIN  (-INT8_MAX - 1)
#define INT16_MIN (-INT16_MAX - 1)
#define INT32_MIN (-INT32_MAX - 1)
#if !defined(__STDC_32_MODE__)
#define INT64_MIN (-INT64_MAX - 1)
#endif

#define INT_LEAST8_MIN  INT8_MIN
#define INT_LEAST16_MIN INT16_MIN
#define INT_LEAST32_MIN INT32_MIN
#if !defined(__STDC_32_MODE__)
#define INT_LEAST64_MIN INT64_MIN
#endif

#define INT_FAST8_MIN  INT32_MIN
#define INT_FAST16_MIN INT32_MIN
#define INT_FAST32_MIN INT32_MIN
#if !defined(__STDC_32_MODE__)
#define INT_FAST64_MIN INT64_MIN
#endif

#define UINT8_MAX      UINT8_C(255)
#define UINT16_MAX     UINT16_C(65535)
#if defined(__STDC__) || defined(__cplusplus)
#  define UINT32_MAX     UINT32_C(4294967295)
#else /* defined(__STDC__) || defined(__cplusplus) */
#  define UINT32_MAX     037777777777
#endif /* defined(__STDC__) || defined(__cplusplus) */
#if !defined(__STDC_32_MODE__)
#define UINT64_MAX     UINT64_C(18446744073709551615)
#endif

#if !defined(__STDC_32_MODE__)
#define INTMAX_MIN INT_LEAST64_MIN
#define INTMAX_MAX INT64_MAX		
#define UINTMAX_MAX UINT64_MAX		

#else /* __STDC_32_MODE__ */
#define INTMAX_MIN INT_LEAST32_MIN
#define INTMAX_MAX INT32_MAX		
#define UINTMAX_MAX UINT32_MAX		

#endif /* __STDC_32_MODE__ */

#define INTFAST_MIN INT_LEAST32_MIN 	
#define INTFAST_MAX INT32_MAX		
#define UINTFAST_MAX UINT32_MAX		

#define INT_LEAST8_MAX  INT8_MAX	
#define INT_LEAST16_MAX INT16_MAX 	
#define INT_LEAST32_MAX INT32_MAX 	
#if !defined(__STDC_32_MODE__)
#define INT_LEAST64_MAX INT64_MAX	
#endif

#define INT_FAST8_MAX  INT32_MAX
#define INT_FAST16_MAX INT32_MAX
#define INT_FAST32_MAX INT32_MAX
#if !defined(__STDC_32_MODE__)
#define INT_FAST64_MAX INT64_MAX
#endif

#define	UINT_LEAST8_MAX	UINT8_MAX
#define	UINT_LEAST16_MAX UINT16_MAX
#define	UINT_LEAST32_MAX UINT32_MAX
#if !defined(__STDC_32_MODE__)
#define	UINT_LEAST64_MAX UINT64_MAX
#endif

#define	UINT_FAST8_MAX	UINT32_MAX
#define	UINT_FAST16_MAX	UINT32_MAX
#define	UINT_FAST32_MAX	UINT32_MAX
#if !defined(__STDC_32_MODE__)
#define	UINT_FAST64_MAX UINT64_MAX	
#endif

/* Max and Min of intptr_t and uintptr_t */

#ifdef __LP64__
#define	INTPTR_MAX INT64_MAX
#else
#define INTPTR_MAX (2147483647l)
#endif

#ifdef __LP64__
#define	UINTPTR_MAX UINT64_MAX
#else
#define UINTPTR_MAX (4294967295ul)
#endif

#ifdef __LP64__
#define	INTPTR_MIN INT64_MIN
#else
#define INTPTR_MIN (-INTPTR_MAX - 1)
#endif

/* Max and Min of ptrdiff_t, the sign is required by the stds */

#ifdef __LP64__
#define	PTRDIFF_MIN INT64_MIN
#else
#define PTRDIFF_MIN (-PTRDIFF_MAX - 1)
#endif

#ifdef __LP64__
#define	PTRDIFF_MAX INT64_MAX
#else
#define PTRDIFF_MAX (2147483647l)
#endif

/* Max and Min of sig_atomic_t */

#define	SIG_ATOMIC_MIN	0
#define	SIG_ATOMIC_MAX	UINT32_MAX

/* Max and Min of size_t */

#ifdef __LP64__
#define	SIZE_MAX UINT64_MAX
#else
#define SIZE_MAX (4294967295ul)
#endif

/* Max and Min of wint_t */
#ifndef WINT_MIN
#define	WINT_MIN 0
#endif
#ifndef WINT_MAX
#define	WINT_MAX UINT32_MAX
#endif

/* Max and Min of wchar_t */
#ifndef WCHAR_MIN
#define WCHAR_MIN 0
#endif
#ifndef WCHAR_MAX
#define WCHAR_MAX UINT32_MAX
#endif

#endif /* (_INCLUDE_STDC__SOURCE_199901) || ( (__cplusplus) && (__STDC_LIMIT_MACROS) ) */
#endif /* _STDINT_INCLUDED */
