/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/sys/pthread.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

/* @(#) pthread.h $Date: 2007/10/30 21:19:51 $Revision: r11.31/1 PATCH_11.31 (B11.31.0803LR) */
/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#) 			common/pthreads/pthread.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/sys/pthread.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/


#ifndef _SYS_PTHREAD_INCLUDED
#define _SYS_PTHREAD_INCLUDED

#include <sys/signal.h>
#include <sys/types.h>

#ifdef _INCLUDE_XOPEN_SOURCE_PRE_500
#include <sys/time.h>
#endif /*_INCLUDE_XOPEN_SOURCE_PRE_500*/

#include <sys/sched.h>

#ifdef __PTHREAD_BUILD
#include <sys/mp.h>
#include <sys/lwpsynch.h>
#endif /* __PTHREAD_BUILD */

#ifdef PTHREAD_COMPAT_MODE
#define __PTHREAD_LIBRARY_VERSION_1     0x1
#else
#define __PTHREAD_LIBRARY_VERSION_1	0x2
#endif


#ifdef _INCLUDE_HPUX_SOURCE 
#  define OPTION_PTHREAD_FORCE_SCOPE_SYSTEM       0x1
#  define OPTION_PTHREAD_FORCE_SCOPE_PROCESS      0x2
#  define OPTION_PTHREAD_DEFAULT_SCOPE_SYSTEM     0x4
#  define OPTION_PTHREAD_DEFAULT_SCOPE_PROCESS    0x8
#  define _POSIX_REENTRANT_FUNCTIONS
#  define _POSIX_THREAD_ATFORK

#ifndef __PTHREAD_BUILD

#if defined(PTHREAD_FORCE_SCOPE_SYSTEM)
    #define PTHREAD_COMPILE_OPTION OPTION_PTHREAD_FORCE_SCOPE_SYSTEM

#elif defined(PTHREAD_FORCE_SCOPE_PROCESS)
    #define PTHREAD_COMPILE_OPTION OPTION_PTHREAD_FORCE_SCOPE_PROCESS

#elif defined(PTHREAD_DEFAULT_SCOPE_PROCESS)
    #define PTHREAD_COMPILE_OPTION OPTION_PTHREAD_DEFAULT_SCOPE_PROCESS

#endif /* PTHREAD_FORCE_SCOPE_SYSTEM */

#endif /* !__PTHREAD_BUILD */
#endif /* _INCLUDE_HPUX_SOURCE */

/************************************************************************
 * The following are the defines supported in this pthread 		*
 * implementation.							*
 *									*
 * THREADS REVISIT: move the following POSIX defines to unistd.h or ???	*
 ************************************************************************/

typedef int   pthread_spu_t;
typedef int   pthread_ldom_t;


/************************************************************************
 * Pthread Attributes Object defines:					*
 ************************************************************************/
#define PTHREAD_CREATE_DETACHED		0xde
#define PTHREAD_CREATE_JOINABLE		0xab

#define PTHREAD_SCOPE_SYSTEM		0x1
#define PTHREAD_SCOPE_PROCESS		0x2
/* 0x4, 0x100, 0x400, 0x800 are reserved by the library for internal use */

#define PTHREAD_INHERIT_SCHED		0x10
#define PTHREAD_EXPLICIT_SCHED		0x20

/* Suspended attribute */
#define PTHREAD_CREATE_SUSPENDED	0x40	/* SUSP */
#define PTHREAD_CREATE_UNSUSPENDED	0x80

/************************************************************************
 * Mutex attributes object.						*
 ************************************************************************/
#define PTHREAD_PROCESS_PRIVATE		0x1
#define PTHREAD_PROCESS_SHARED		0x2

#define PTHREAD_MUTEX_NORMAL		0x10
#define PTHREAD_MUTEX_RECURSIVE		0x20
#define PTHREAD_MUTEX_ERRORCHECK	0x40
#define PTHREAD_MUTEX_DEFAULT		0x80
#define PTHREAD_MUTEX_NO_OWNER_NP	0x800

#define	PTHREAD_PRIO_NONE		0x100
#define PTHREAD_PRIO_PROTECT		0x200
#define	PTHREAD_PRIO_INHERIT		0x400
/* 0x1000, 0x2000 reserved for internal use */

#define __PTHREAD_MUTEX_VALID		0x36
#define __LWP_MTX_VALID          	2368

#define __SPNLCK_INITIALIZER						\
	{ 1, 1, 1, 1 },							\
	__POINTER_SET,							\
	{ 1, 0 }

#define PTHREAD_MUTEX_INITIALIZER  {					\
	{ __PTHREAD_MUTEX_VALID, 0 },					\
	(PTHREAD_MUTEX_DEFAULT | PTHREAD_PROCESS_PRIVATE),		\
	__SPNLCK_INITIALIZER,						\
	{ 0, 0, -1, 0 },						\
	{ 0, __LWP_MTX_VALID }, { 0, 1, 1, 1, 1 },			\
	{ 0, 0 }							\
}

#define PTHREAD_MUTEX_NORMAL_INITIALIZER_NP  {				\
	{ __PTHREAD_MUTEX_VALID, 0 },					\
	(PTHREAD_MUTEX_NORMAL | PTHREAD_PROCESS_PRIVATE),		\
	__SPNLCK_INITIALIZER,						\
	{ 0, 0, -1, 0 },						\
	{ 0, __LWP_MTX_VALID }, { 0, 1, 1, 1, 1 },			\
	{ 0, 0 }							\
}

#define PTHREAD_MUTEX_NO_OWNER_INITIALIZER_NP  { 			\
        { __PTHREAD_MUTEX_VALID, 0 },                                       \
        (PTHREAD_MUTEX_NO_OWNER_NP | PTHREAD_PROCESS_PRIVATE),          \
        __SPNLCK_INITIALIZER,                                           \
	{ 0, 0, -1, 0 },						\
        { 0, __LWP_MTX_VALID }, { 0, 1, 1, 1, 1 },			\
	{ 0, 0 }							\
}


#define PTHREAD_MUTEX_RECURSIVE_INITIALIZER_NP  {			\
	{ __PTHREAD_MUTEX_VALID, 0 },					\
	(PTHREAD_MUTEX_RECURSIVE | PTHREAD_PROCESS_PRIVATE),		\
	__SPNLCK_INITIALIZER,						\
	{ 0, 0, -1, 0 },						\
	{ 0, __LWP_MTX_VALID }, { 0, 1, 1, 1, 1 },			\
	{ 0, 0 }							\
}

#define PTHREAD_MUTEX_ERRORCHECK_INITIALIZER_NP  {			\
	{ __PTHREAD_MUTEX_VALID, 0 },					\
	(PTHREAD_MUTEX_ERRORCHECK | PTHREAD_PROCESS_PRIVATE),		\
	__SPNLCK_INITIALIZER,						\
	{ 0, 0, -1, 0 },						\
	{ 0, __LWP_MTX_VALID }, { 0, 1, 1, 1, 1 },			\
	{ 0, 0 }							\
}


/************************************************************************
 * Condition variable object.						*
 ************************************************************************/

#define __PTHREAD_COND_VALID		0x26
#define __LWP_COND_VALID         	5467

#define PTHREAD_COND_INITIALIZER  {					\
	{ __PTHREAD_COND_VALID, 0 },					\
	PTHREAD_PROCESS_PRIVATE,					\
	__SPNLCK_INITIALIZER,						\
	{ __LWP_COND_VALID, 0 },					\
	{ 0, 0 }							\
}

#define __PTHREAD_RWLOCK_VALID		0x8c
#define __LWP_RWLOCK_VALID          	0x8c91

#define PTHREAD_RWLOCK_INITIALIZER  {					\
	{ __PTHREAD_RWLOCK_VALID, 0 },					\
	PTHREAD_PROCESS_PRIVATE, 					\
	__SPNLCK_INITIALIZER,						\
	{ __LWP_RWLOCK_VALID, 0 },					\
	{ 0, 0, 0, 0, 0 }, { 0, 0}					\
}


#define PTHREAD_ONCE_INIT  {	\
	0,				/* po_executed */	\
	0,				/* po_completed */	\
	PTHREAD_MUTEX_INITIALIZER,	/* po_mutex */	\
	PTHREAD_COND_INITIALIZER,	/* po_cond */	\
}


/************************************************************************
 * Cancellation defines:						*
 ************************************************************************/

#define PTHREAD_CANCEL_DISABLE		0
#define PTHREAD_CANCEL_ENABLE		1

#define PTHREAD_CANCEL_DEFERRED		0
#define PTHREAD_CANCEL_ASYNCHRONOUS	1

#define PTHREAD_CANCELED		((void *) -3)

typedef struct __pthread_cleanup_handler_t {
		struct __pthread_cleanup_handler_t *__next_handler;
#ifdef _PROTOTYPES
		void (*__handler_function)(void *);
#else /* ! _PROTOTYPES */
		void (*__handler_function)();
#endif /* !_PROTOTYPES */
		void *__handler_arg;
} __pthread_cleanup_handler_t;

#ifdef __cplusplus
    extern "C" {
#endif /* __cplusplus */

#ifdef __ia64 
#  pragma extern __pthread_cancel_stack
#endif /* __ia64 */ 

#ifdef _PROTOTYPES
extern __pthread_cleanup_handler_t	**__pthread_cancel_stack(void);
#else /* ! _PROTOTYPES */
extern __pthread_cleanup_handler_t	**__pthread_cancel_stack();
#endif /* !_PROTOTYPES */

#ifdef __cplusplus
    }
#endif /* __cplusplus */

#define pthread_cleanup_push(func, arg) 	\
	__pth_cleanup_push(func, arg, __pthread_cancel_stack())

#define __pth_cleanup_push(func, arg, specific) {	\
	__pthread_cleanup_handler_t __handler, **__handler_queue;	\
	__handler.__handler_function = func;	\
	__handler.__handler_arg = arg;	\
	__handler_queue = (__pthread_cleanup_handler_t **)(specific); \
	__handler.__next_handler = *__handler_queue;	\
	*__handler_queue = &__handler;

#define pthread_cleanup_pop(execute)	\
	*__handler_queue = __handler.__next_handler;	\
	if (execute)	\
		(*__handler.__handler_function)(__handler.__handler_arg);  \
}


/************************************************************************
 * pthread_processor_num_np(), pthread_processor_bind_np(),		*
 * pthread_attr_setprocessor_np(), pthread_num_ldoms_np(),		*
 * pthread_num_ldomprocs_np(), pthread_ldom_id_np(),			*
 * pthread_spu_to_ldom_np(), pthread_ldom_bind_np(),			*
 * pthread_launch_policy_np(), pthread_pset_bind_np()			*
 ************************************************************************/

#define PTHREAD_GETFIRSTSPU_NP		1
#define PTHREAD_GETNEXTSPU_NP		2
#define PTHREAD_GETCURRENTSPU_NP	3

#define PTHREAD_BIND_ADVISORY_NP	4
#define PTHREAD_BIND_FORCED_NP		5
#define PTHREAD_BIND_LDOM_NP		6
#define PTHREAD_BIND_NONE_NP		7

#define PTHREAD_GETFIRSTLDOM_NP		8
#define	PTHREAD_GETNEXTLDOM_NP		9

#define PTHREAD_GET_POLICY_NP		100
#define PTHREAD_POLICY_NONE_NP		101
#define PTHREAD_POLICY_RR_NP		102
#define PTHREAD_POLICY_FILL_NP		103
#define PTHREAD_POLICY_PACKED_NP	104
#define PTHREAD_POLICY_LEASTLOAD_NP	106
#define PTHREAD_POLICY_RR_TREE_NP	107
#define PTHREAD_POLICY_FILL_TREE_NP	108

#define PTHREAD_SPUFLOAT_NP		((pthread_spu_t) -1)
#define PTHREAD_SPUNOCHANGE_NP		((pthread_spu_t) -2)
#define PTHREAD_SPUINHERIT_NP		((pthread_spu_t) -3)

#define PTHREAD_LDOMFLOAT_NP		((pthread_ldom_t) -4)
#define PTHREAD_LDOMNOCHANGE_NP		((pthread_ldom_t) -5)
#define PTHREAD_LDOMINHERIT_NP		((pthread_ldom_t) -6)

#define PTHREAD_PSETNOCHANGE_NP		((psetid_t) -7)

#define PTHREAD_SELFTID_NP		((pthread_t) 0)

#define PTHREAD_MAXTSLICE_NP		999

#define PTHREAD_SAVEMORE_CONTEXT	-111

/************************************************************************
 * pthread_resume_np() resume options					* 
 ************************************************************************/
#define PTHREAD_COUNT_RESUME_NP		0x1
#define PTHREAD_FORCE_RESUME_NP		0x2


/************************************************************************
 * HP/Convex Exemplar SPP/UX extensions related defines                 *
 ************************************************************************/
#define PTHREAD_MEM_TYPE_DEFAULT_NP	1
#define PTHREAD_MEM_TYPE_FAR_NP		2
#define PTHREAD_MEM_TYPE_NEAR_NP	3
#define PTHREAD_MEM_TYPE_NODE_NP	4

#define PTHREAD_SAME_NODE_NP		-1
#define PTHREAD_ANY_NODE_NP		-2


/************************************************************************
 * pthread_callback_np extension related defines			*
 ************************************************************************/
#define PTHREAD_PARENT_NP		1
#define PTHREAD_CHILD_NP		2
#define PTHREAD_EXIT_NP			3

#define PTHREAD_USWTCH_OUT_NP           4
#define PTHREAD_USWTCH_IN_NP            5

/************************************************************************
 * Arguments for pthread_mutexattr_{s,g}etspin_np() and			*
 * 	pthread_mutex_{s,g}etyieldfreq_np()				*
 ************************************************************************/

#define PTHREAD_MUTEX_SPINDEFAULT_NP	0
#define PTHREAD_MUTEX_SPINONLY_NP	-1

#define PTHREAD_MUTEX_YIELDFREQDEFAULT_NP	0
#define PTHREAD_MUTEX_YIELDNEVER_NP		-1



/************************************************************************
 * _pthread_stack_info                                                  *
 ************************************************************************/
#define PTHREAD_STACK_UP_NP	0x10000000
#define PTHREAD_STACK_DOWN_NP	0x20000000

#define PTHREAD_64BIT_APP_NP	0x01000000
#define PTHREAD_32BIT_APP_NP	0x02000000

#define PTHREAD_STACK_INVALID_NP	0
#define PTHREAD_STACK_VALID_NP		1

#ifdef _INCLUDE_HPUX_SOURCE
typedef struct _pthread_stack_info {
	int	stk_flags;

	/* Size of the stack */
	short	stk_stacksize_valid;
	size_t	stk_stacksize;

	/* Size of the guard page at the end of the stack */
	short	stk_guardsize_valid;
	size_t	stk_guardsize;

	/* Size of the Register Stack */
	short	stk_rsestacksize_valid;
	size_t	stk_rsestacksize;

	/* Reserved for future use -- do not use, names WILL change */
	short	stk_reserved1_valid;
	size_t	stk_reserved1_size;

	/* Address of the base of the stack */
	void	*stk_stack_base;

	/* Base of RSE BS.  Filled in only for IA64.  Do not use on PA. */
	void	*stk_rse_base;

	/* Current stack pointer value */
	void	*stk_sp;

	/* Thread bsp.  Filled in only for IA64.  Do not use on PA. */
	void	*stk_bsp;

	/* Current program counter value */
	void	*stk_pc;

	/* Reserved for future use -- do not use, names WILL change */
	void	*stk_reserved[25];
} _pthread_stack_info_t;
#endif


/************************************************************************
 * Prototypes for the pthread functions:				*
 ************************************************************************/

#ifdef __cplusplus
    extern "C" {
#endif /* __cplusplus */

#ifdef __ia64 
#  pragma extern pthread_atfork
#  ifdef __lint
#    pragma extern pthread_create
#  else 
#      if defined(PTHREAD_COMPAT_MODE)
#         pragma extern __pthread_create_system
#      elif defined(PTHREAD_COMPILE_OPTION)
#         pragma extern __pthread_create_generic
#      else
#         pragma extern pthread_create
#      endif
#  endif /*  ! __lint */
#  pragma extern pthread_exit, pthread_join, pthread_once, pthread_detach
#  pragma extern pthread_self, pthread_equal, pthread_getschedparam
#  pragma extern pthread_setschedparam, pthread_default_stacksize_np
#  pragma extern pthread_default_rsestacksize_np, pthread_setschedprio 
#endif /* __ia64 */ 

#if defined(_HP_SHLIB_CALLS)
#      pragma HP_DEFINED_EXTERNAL __pthread_cancel, __pthread_setcancelstate
#      pragma HP_DEFINED_EXTERNAL __pthread_setcanceltype, __pthread_testcancel
#      pragma HP_DEFINED_EXTERNAL __pthread_cond_init, __pthread_cond_destroy
#      pragma HP_DEFINED_EXTERNAL __pthread_cond_signal,__pthread_cond_broadcast
#      pragma HP_DEFINED_EXTERNAL __pthread_cond_wait, __pthread_cond_timedwait
#      pragma HP_DEFINED_EXTERNAL __pthread_suspend, __pthread_num_processors_np
#      pragma HP_DEFINED_EXTERNAL __pthread_continue, __pthread_setconcurrency
#      pragma HP_DEFINED_EXTERNAL __pthread_getconcurrency, __pthread_resume_np
#      pragma HP_DEFINED_EXTERNAL __pthread_processor_id_np, __pthread_atfork
#      pragma HP_DEFINED_EXTERNAL __pthread_processor_bind_np, __pthread_self
#      pragma HP_DEFINED_EXTERNAL __pthread_pset_bind_np
#      pragma HP_DEFINED_EXTERNAL __pthread_mutex_init, __pthread_mutex_destroy 
#      pragma HP_DEFINED_EXTERNAL __pthread_mutex_trylock, __pthread_mutex_lock 
#      pragma HP_DEFINED_EXTERNAL __pthread_mutex_unlock, __pthread_exit
#      pragma HP_DEFINED_EXTERNAL __pthread_mutex_setprioceiling,__pthread_equal
#      pragma HP_DEFINED_EXTERNAL __pthread_mutex_getprioceiling
#      pragma HP_DEFINED_EXTERNAL __pthread_create, __pthread_create_system
#      pragma HP_DEFINED_EXTERNAL __pthread_join, __pthread_detach
#      pragma HP_DEFINED_EXTERNAL __pthread_getschedparam, __pthread_once
#      pragma HP_DEFINED_EXTERNAL __pthread_setschedparam, __pthread_kill
#      pragma HP_DEFINED_EXTERNAL __pthread_setschedprio  
#      pragma HP_DEFINED_EXTERNAL __pthread_rwlock_init,__pthread_rwlock_destroy
#      pragma HP_DEFINED_EXTERNAL __pthread_rwlock_rdlock, pthread_rwlock_unlock
#      pragma HP_DEFINED_EXTERNAL __pthread_rwlock_wrlock, __pthread_sigmask
#      pragma HP_DEFINED_EXTERNAL __pthread_rwlock_tryrdlock
#      pragma HP_DEFINED_EXTERNAL __pthread_rwlock_trywrlock
#      pragma HP_DEFINED_EXTERNAL __pthread_key_create, __pthread_key_delete
#      pragma HP_DEFINED_EXTERNAL __pthread_getspecific, __pthread_setspecific
#      pragma HP_DEFINED_EXTERNAL __pthread_get_nice_np, __pthread_set_nice_np
#      pragma HP_DEFINED_EXTERNAL __pthread_getlwpid_np
#endif /* defined(_HP_SHLIB_CALLS) && ! defined(__LP64__) */

#if defined(_FAST_SHLIB_CALLS) && ! defined(__LP64__) && ! defined(__ia64)
#      pragma HP_NO_RELOCATION __pthread_cancel, __pthread_setcancelstate
#      pragma HP_NO_RELOCATION __pthread_setcanceltype, __pthread_testcancel
#      pragma HP_NO_RELOCATION __pthread_cond_init, __pthread_cond_destroy
#      pragma HP_NO_RELOCATION __pthread_cond_signal,__pthread_cond_broadcast
#      pragma HP_NO_RELOCATION __pthread_cond_wait, __pthread_cond_timedwait
#      pragma HP_NO_RELOCATION __pthread_suspend, __pthread_num_processors_np
#      pragma HP_NO_RELOCATION __pthread_continue, __pthread_setconcurrency
#      pragma HP_NO_RELOCATION __pthread_getconcurrency, __pthread_resume_np
#      pragma HP_NO_RELOCATION __pthread_processor_id_np, __pthread_atfork
#      pragma HP_NO_RELOCATION __pthread_processor_bind_np, __pthread_self
#      pragma HP_NO_RELOCATION __pthread_pset_bind_np
#      pragma HP_NO_RELOCATION __pthread_mutex_init, __pthread_mutex_destroy 
#      pragma HP_NO_RELOCATION __pthread_mutex_trylock, __pthread_mutex_lock 
#      pragma HP_NO_RELOCATION __pthread_mutex_unlock, __pthread_exit
#      pragma HP_NO_RELOCATION __pthread_mutex_setprioceiling,__pthread_equal
#      pragma HP_NO_RELOCATION __pthread_mutex_getprioceiling
#      pragma HP_NO_RELOCATION __pthread_create, __pthread_create_system
#      pragma HP_NO_RELOCATION __pthread_join, __pthread_detach
#      pragma HP_NO_RELOCATION __pthread_getschedparam, __pthread_once
#      pragma HP_NO_RELOCATION __pthread_setschedparam, __pthread_kill
#      pragma HP_NO_RELOCATION __pthread_setschedprio  
#      pragma HP_NO_RELOCATION __pthread_rwlock_init,__pthread_rwlock_destroy
#      pragma HP_NO_RELOCATION __pthread_rwlock_rdlock, pthread_rwlock_unlock
#      pragma HP_NO_RELOCATION __pthread_rwlock_wrlock, __pthread_sigmask
#      pragma HP_NO_RELOCATION __pthread_rwlock_tryrdlock
#      pragma HP_NO_RELOCATION __pthread_rwlock_trywrlock
#      pragma HP_NO_RELOCATION __pthread_key_create, __pthread_key_delete
#      pragma HP_NO_RELOCATION __pthread_getspecific, __pthread_setspecific
#      pragma HP_NO_RELOCATION __pthread_get_nice_np, __pthread_set_nice_np
#      pragma HP_NO_RELOCATION __pthread_getlwpid_np

#      pragma HP_LONG_RETURN __pthread_cancel, __pthread_setcancelstate
#      pragma HP_LONG_RETURN __pthread_setcanceltype, __pthread_testcancel
#      pragma HP_LONG_RETURN __pthread_cond_init, __pthread_cond_destroy
#      pragma HP_LONG_RETURN __pthread_cond_signal,__pthread_cond_broadcast
#      pragma HP_LONG_RETURN __pthread_cond_wait, __pthread_cond_timedwait
#      pragma HP_LONG_RETURN __pthread_suspend, __pthread_num_processors_np
#      pragma HP_LONG_RETURN __pthread_continue, __pthread_setconcurrency
#      pragma HP_LONG_RETURN __pthread_getconcurrency, __pthread_resume_np
#      pragma HP_LONG_RETURN __pthread_processor_id_np, __pthread_atfork
#      pragma HP_LONG_RETURN __pthread_processor_bind_np, __pthread_self
#      pragma HP_LONG_RETURN __pthread_pset_bind_np
#      pragma HP_LONG_RETURN __pthread_mutex_init, __pthread_mutex_destroy 
#      pragma HP_LONG_RETURN __pthread_mutex_trylock, __pthread_mutex_lock 
#      pragma HP_LONG_RETURN __pthread_mutex_unlock, __pthread_exit
#      pragma HP_LONG_RETURN __pthread_mutex_setprioceiling,__pthread_equal
#      pragma HP_LONG_RETURN __pthread_mutex_getprioceiling
#      pragma HP_LONG_RETURN __pthread_create, __pthread_create_system
#      pragma HP_LONG_RETURN __pthread_join, __pthread_detach
#      pragma HP_LONG_RETURN __pthread_getschedparam, __pthread_once
#      pragma HP_LONG_RETURN __pthread_setschedparam, __pthread_kill
#      pragma HP_LONG_RETURN __pthread_setschedprio  
#      pragma HP_LONG_RETURN __pthread_rwlock_init,__pthread_rwlock_destroy
#      pragma HP_LONG_RETURN __pthread_rwlock_rdlock, pthread_rwlock_unlock
#      pragma HP_LONG_RETURN __pthread_rwlock_wrlock, __pthread_sigmask
#      pragma HP_LONG_RETURN __pthread_rwlock_tryrdlock
#      pragma HP_LONG_RETURN __pthread_rwlock_trywrlock
#      pragma HP_LONG_RETURN __pthread_key_create, __pthread_key_delete
#      pragma HP_LONG_RETURN __pthread_getspecific, __pthread_setspecific
#      pragma HP_LONG_RETURN __pthread_get_nice_np, __pthread_set_nice_np
#      pragma HP_LONG_RETURN __pthread_getlwpid_np

#endif /* defined(_FAST_SHLIB_CALLS) && ! defined(__LP64__)	*/

#if defined(_PROTOTYPES) && !defined(PTHREAD_TRACE)

	extern int pthread_atfork(void (*)(void), void (*)(void), void (*)(void));
#ifdef __lint
	extern int pthread_create(pthread_t * __restrict, 
				  const pthread_attr_t * __restrict,
                                  void *(*)(void *), 
				  void * __restrict);
#else /* ! __lint */
#if defined(PTHREAD_COMPAT_MODE)
	extern int __pthread_create_system(pthread_t * __restrict, 
				 	   const pthread_attr_t * __restrict,
                                  	   void *(*)(void *), 
					   void * __restrict);

#ifdef __cplusplus
	inline int pthread_create(
#else /* !__cplusplus */
	static int pthread_create(
#endif /* !__cplusplus */
				  pthread_t * __restrict __tid, 
				  const pthread_attr_t * __restrict __attr,
                                  void *(*__start_routine)(void *), 
				  void * __restrict __arg)
	    { return(__pthread_create_system(__tid, __attr, __start_routine, __arg)); }
#elif defined(PTHREAD_COMPILE_OPTION)
	extern int __pthread_create_generic(pthread_t * __restrict __tid, 
				 	   const pthread_attr_t * __restrict __attr,
                                  	   void *(*__start_routine)(void *), 
					   void * __restrict __arg, unsigned short __new_compile_option);

#ifdef __cplusplus
	inline int pthread_create(
#else /* !__cplusplus */
	static int pthread_create(
#endif /* !__cplusplus */
				  pthread_t * __restrict __tid, 
				  const pthread_attr_t * __restrict __attr,
                                  void *(*__start_routine)(void *), 
				  void * __restrict __arg)
	    { return(__pthread_create_generic(__tid, __attr, __start_routine, __arg, PTHREAD_COMPILE_OPTION)); }
#else   
        extern int pthread_create(pthread_t * __restrict __tid, 
                                  const pthread_attr_t * __restrict __attr,
                                  void *(*__start_routine)(void *), 
                                  void * __restrict __arg);
#endif 
#endif /* ! __lint */

	extern void pthread_exit(void *);
	extern int pthread_join(pthread_t, void **);
	extern int pthread_once(pthread_once_t *, void (*)(void));
	extern int pthread_detach(pthread_t);
	extern pthread_t pthread_self(void);
	extern int pthread_equal(pthread_t, pthread_t);
	extern int pthread_getschedparam(pthread_t, int * __restrict, 
						struct sched_param * __restrict);
	extern int pthread_setschedparam(pthread_t, int, const struct sched_param *);
	extern int pthread_setschedprio(pthread_t, int); 
	extern int pthread_default_stacksize_np(size_t, size_t *);
	extern int pthread_default_rsestacksize_np(size_t, size_t *);

#else /* not _PROTOTYPES */

	extern int pthread_atfork();
#ifdef __lint
	extern int pthread_create();
#else /* ! __lint */
#if defined(PTHREAD_COMPAT_MODE)
	extern int __pthread_create_system();
	static int pthread_create(tid, attr, start_routine, arg)
			pthread_t *tid;
			pthread_attr_t *attr;
			void *(*start_routine)();
			void *arg;
	    { return(__pthread_create_system(tid, attr, start_routine, arg)); }
#elif defined(PTHREAD_COMPILE_OPTION)
	extern int __pthread_create_generic();
	static int pthread_create(tid, attr, start_routine, arg)
			pthread_t *tid;
			pthread_attr_t *attr;
			void *(*start_routine)();
			void *arg;
	    { return(__pthread_create_generic(tid, attr, start_routine, arg, PTHREAD_COMPILE_OPTION)); }
#else
        extern int pthread_create();
#endif /* defined(PTHREAD_COMPAT_MODE) */
#endif /* ! __lint */

	extern void pthread_exit();
	extern int pthread_join();
	extern int pthread_once();
	extern int pthread_detach();
	extern pthread_t pthread_self();
	extern int pthread_equal();
	extern int pthread_getschedparam();
	extern int pthread_setschedparam();
	extern int pthread_setschedprio(); 
	extern int pthread_default_stacksize_np();
	extern int pthread_default_rsestacksize_np();
#endif /* _PROTOTYPES */

/************************************************************************
 * Prototypes for the pthread attributes object functions:		*
 ************************************************************************/

#ifdef __ia64 
#  ifdef __lint
#    pragma extern pthread_attr_init
#  else 
#    if defined(PTHREAD_COMPAT_MODE)
#       pragma extern __pthread_attr_init_system
#    elif defined(PTHREAD_COMPILE_OPTION)
#         pragma extern __pthread_attr_init_generic
#    else
#       pragma extern pthread_attr_init
#    endif
#  endif /* ! __lint */
#  pragma extern  pthread_attr_destroy, pthread_attr_getdetachstate
#  pragma extern pthread_attr_setdetachstate, pthread_attr_getinheritsched
#  pragma extern pthread_attr_getschedparam, pthread_attr_getschedpolicy
#  pragma extern pthread_attr_getscope, pthread_attr_setinheritsched
#  pragma extern pthread_attr_setschedparam, pthread_attr_setschedpolicy
#  pragma extern pthread_attr_setscope, pthread_attr_getstacksize 
#  pragma extern pthread_attr_setstacksize, pthread_attr_getstackaddr
#  pragma extern pthread_attr_setstackaddr, pthread_attr_getguardsize
#  pragma extern pthread_attr_setguardsize, pthread_attr_getprocessor_np
#  pragma extern pthread_attr_getprocessor_np
#ifdef _INCLUDE_XOPEN_SOURCE_600
#  pragma extern pthread_attr_getstack, pthread_attr_setstack
#endif /* _INCLUDE_XOPEN_SOURCE_600 */
#endif /* __ia64 */ 

#ifdef _PROTOTYPES

#ifdef __lint
	extern int pthread_attr_init(pthread_attr_t *);
#else /* ! __lint */
#if defined(PTHREAD_COMPAT_MODE)
	extern int __pthread_attr_init_system(pthread_attr_t *attr);

#ifdef __cplusplus
	inline int pthread_attr_init(
#else /* !__cplusplus */
	static int pthread_attr_init(
#endif /* !__cplusplus */
				     pthread_attr_t *attr)
		   { return(__pthread_attr_init_system(attr)); }
#elif defined(PTHREAD_COMPILE_OPTION)
        extern int __pthread_attr_init_generic(pthread_attr_t *attr, unsigned short new_compile_option);

#ifdef __cplusplus
        inline int pthread_attr_init(
#else /* !__cplusplus */
        static int pthread_attr_init(
#endif /* !__cplusplus */
                                     pthread_attr_t *attr)
                   { return(__pthread_attr_init_generic(attr, PTHREAD_COMPILE_OPTION)); }
#else
        extern int pthread_attr_init(pthread_attr_t *);
#endif /* defined(PTHREAD_COMPAT_MODE) */
#endif /* ! __lint */

	extern int pthread_attr_destroy(pthread_attr_t *);
	extern int pthread_attr_getdetachstate(const pthread_attr_t *, int *);
	extern int pthread_attr_setdetachstate(pthread_attr_t *, int);
	extern int pthread_attr_getinheritsched(const pthread_attr_t * __restrict, int * __restrict);
	extern int pthread_attr_getschedparam(const pthread_attr_t * __restrict, 
							struct sched_param * __restrict);
	extern int pthread_attr_getschedpolicy(const pthread_attr_t * __restrict, int * __restrict);
	extern int pthread_attr_getscope(const pthread_attr_t * __restrict, int * __restrict);
	extern int pthread_attr_setinheritsched(pthread_attr_t *, int);
	extern int pthread_attr_setschedparam(pthread_attr_t * __restrict,
						const struct sched_param * __restrict);
	extern int pthread_attr_setschedpolicy(pthread_attr_t *, int);
	extern int pthread_attr_setscope(pthread_attr_t *, int);
	extern int pthread_attr_getstacksize(const pthread_attr_t * __restrict, size_t * __restrict);
	extern int pthread_attr_setstacksize(pthread_attr_t *, size_t);
	extern int pthread_attr_getstackaddr(const pthread_attr_t * __restrict, void  ** __restrict);
	extern int pthread_attr_setstackaddr(pthread_attr_t *, void *);
	extern int pthread_attr_getguardsize(const pthread_attr_t * __restrict, size_t * __restrict);
	extern int pthread_attr_setguardsize(pthread_attr_t *, size_t);
	extern int pthread_attr_getprocessor_np(const pthread_attr_t *, pthread_spu_t *, int *);
	extern int pthread_attr_setprocessor_np(pthread_attr_t *, pthread_spu_t, int );
#ifdef _INCLUDE_XOPEN_SOURCE_600
	extern int pthread_attr_getstack(const pthread_attr_t * __restrict, void ** __restrict, size_t * __restrict);
	extern int pthread_attr_setstack(pthread_attr_t *, void *, size_t);
#endif /* _INCLUDE_XOPEN_SOURCE_600 */
#else /* not _PROTOTYPES */

#ifdef __lint
        extern int pthread_attr_init();
#else /* ! __lint */
#if defined(PTHREAD_COMPAT_MODE)
        extern int __pthread_attr_init_system();

        static int pthread_attr_init(attr)
		   pthread_attr_t *attr;
                   { return(__pthread_attr_init_system(attr)); }
#elif defined(PTHREAD_COMPILE_OPTION)
        extern int __pthread_attr_init_generic();

        static int pthread_attr_init(attr)
                   pthread_attr_t *attr;
                   { return(__pthread_attr_init_generic(attr, PTHREAD_COMPILE_OPTION)); }
#else 
        extern int pthread_attr_init();
#endif /* defined(PTHREAD_COMPAT_MODE) */
#endif /* ! __lint */

	extern int pthread_attr_destroy();
	extern int pthread_attr_getdetachstate();
	extern int pthread_attr_setdetachstate();
	extern int pthread_attr_getinheritsched();
	extern int pthread_attr_getschedparam();
	extern int pthread_attr_getschedpolicy();
	extern int pthread_attr_getscope();
	extern int pthread_attr_setinheritsched();
	extern int pthread_attr_setschedparam();
	extern int pthread_attr_setschedpolicy();
	extern int pthread_attr_setscope();
	extern int pthread_attr_getstacksize();
	extern int pthread_attr_setstacksize();
	extern int pthread_attr_getstackaddr();
	extern int pthread_attr_setstackaddr();
	extern int pthread_attr_getguardsize();
	extern int pthread_attr_setguardsize();
	extern int pthread_attr_getprocessor_np();
	extern int pthread_attr_setprocessor_np();
#ifdef _INCLUDE_XOPEN_SOURCE_600
	extern int pthread_attr_getstack();
	extern int pthread_attr_setstack();
#endif /* _INCLUDE_XOPEN_SOURCE_600 */
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_attr_setrsestacksize_np, pthread_attr_getrsestacksize_np
#endif /* __ia64 */  

	extern int pthread_attr_getrsestacksize_np __((const pthread_attr_t *, size_t * ));
	extern int pthread_attr_setrsestacksize_np __((pthread_attr_t *, size_t));

#ifdef __ia64 
#  pragma extern pthread_mutexattr_init, pthread_mutexattr_destroy
#  pragma extern pthread_mutexattr_getpshared, pthread_mutexattr_setpshared
#  pragma extern pthread_mutexattr_getprotocol, pthread_mutexattr_setprotocol
#  pragma extern pthread_mutexattr_getprioceiling 
#  pragma extern pthread_mutexattr_setprioceiling
#  pragma extern pthread_mutexattr_gettype, pthread_mutexattr_settype
#  pragma extern pthread_mutexattr_getspin_np, pthread_mutexattr_setspin_np
#endif /* __ia64 */  
/************************************************************************
 * Prototypes for the mutex attributes object functions:		*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_mutexattr_init(pthread_mutexattr_t *);
	extern int pthread_mutexattr_destroy(pthread_mutexattr_t *);
	extern int pthread_mutexattr_getpshared(const pthread_mutexattr_t * __restrict,
								 int * __restrict);
	extern int pthread_mutexattr_setpshared(pthread_mutexattr_t *, int);
	extern int pthread_mutexattr_getprotocol(const pthread_mutexattr_t * __restrict,
								 int * __restrict);
	extern int pthread_mutexattr_setprotocol(pthread_mutexattr_t *, int);
	extern int pthread_mutexattr_getprioceiling(const pthread_mutexattr_t *
			       			__restrict, int * __restrict);
	extern int pthread_mutexattr_setprioceiling(pthread_mutexattr_t *, int);
	extern int pthread_mutexattr_gettype(const pthread_mutexattr_t * __restrict, int * __restrict);
	extern int pthread_mutexattr_settype(pthread_mutexattr_t *, int);
	extern int pthread_mutexattr_getspin_np(const pthread_mutexattr_t *,
									int *);
	extern int pthread_mutexattr_setspin_np(pthread_mutexattr_t *, int);
#else /* not _PROTOTYPES */
	extern int pthread_mutexattr_init();
	extern int pthread_mutexattr_destroy();
	extern int pthread_mutexattr_getpshared();
	extern int pthread_mutexattr_setpshared();
	extern int pthread_mutexattr_getprotocol();
	extern int pthread_mutexattr_setprotocol();
	extern int pthread_mutexattr_getprioceiling();
	extern int pthread_mutexattr_setprioceiling();
	extern int pthread_mutexattr_gettype();
	extern int pthread_mutexattr_settype();
	extern int pthread_mutexattr_getspin_np();
	extern int pthread_mutexattr_setspin_np();
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_mutex_init, pthread_mutex_destroy
#  pragma extern pthread_mutex_lock, pthread_mutex_trylock
#  pragma extern pthread_mutex_unlock, pthread_mutex_getprioceiling
#  pragma extern pthread_mutex_setprioceiling, pthread_mutex_getyieldfreq_np
#  pragma extern pthread_mutex_setyieldfreq_np
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the mutex functions:					*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_mutex_init(pthread_mutex_t * __restrict, 
					const pthread_mutexattr_t * __restrict);
	extern int pthread_mutex_destroy(pthread_mutex_t *);
	extern int pthread_mutex_lock(pthread_mutex_t *);
	extern int pthread_mutex_trylock(pthread_mutex_t *);
	extern int pthread_mutex_unlock(pthread_mutex_t *);
	extern int pthread_mutex_getprioceiling(pthread_mutex_t *__restrict, int * __restrict);
	extern int pthread_mutex_setprioceiling(pthread_mutex_t * __restrict, int, int * __restict);
	extern int pthread_mutex_getyieldfreq_np(int *);
	extern int pthread_mutex_setyieldfreq_np(int);
#else /* not _PROTOTYPES */
	extern int pthread_mutex_init();
	extern int pthread_mutex_destroy();
	extern int pthread_mutex_lock();
	extern int pthread_mutex_trylock();
	extern int pthread_mutex_unlock();
	extern int pthread_mutex_getprioceiling();
	extern int pthread_mutex_setprioceiling();
	extern int pthread_mutex_getyieldfreq_np();
	extern int pthread_mutex_setyieldfreq_np();
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_condattr_destroy, pthread_condattr_init
#  pragma extern pthread_condattr_getpshared, pthread_condattr_setpshared
#endif /* __ia64 */  
/************************************************************************
 * Prototypes for the condition variable attributes object functions:	*
 ************************************************************************/

	extern int pthread_condattr_destroy __((pthread_condattr_t *));
	extern int pthread_condattr_init __((pthread_condattr_t *));
	extern int pthread_condattr_getpshared __((const pthread_condattr_t * __restrict, int * __restrict));
	extern int pthread_condattr_setpshared __((pthread_condattr_t *, int));

#ifdef __ia64 
#  pragma extern pthread_cond_destroy, pthread_cond_init, pthread_cond_signal
#  pragma extern pthread_cond_broadcast, pthread_cond_wait 
#  pragma extern pthread_cond_timedwait
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the condition variable functions:			*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_cond_destroy(pthread_cond_t *); 
	extern int pthread_cond_init(pthread_cond_t * __restrict,
				     const pthread_condattr_t * __restrict);
	extern int pthread_cond_signal(pthread_cond_t *);
	extern int pthread_cond_broadcast(pthread_cond_t *);
	extern int pthread_cond_wait(pthread_cond_t * __restrict,
                                     pthread_mutex_t * __restrict);
	extern int pthread_cond_timedwait(pthread_cond_t * __restrict, 
		pthread_mutex_t * __restrict,
                const struct timespec * __restrict);
#else /* not _PROTOTYPES */
	extern int pthread_cond_destroy();
	extern int pthread_cond_init();
	extern int pthread_cond_signal();
	extern int pthread_cond_broadcast();
	extern int pthread_cond_wait();
	extern int pthread_cond_timedwait();
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_rwlockattr_init, pthread_rwlockattr_destroy
#  pragma extern pthread_rwlockattr_getpshared, pthread_rwlockattr_setpshared
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the read/write mutex attributes object functions:	*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_rwlockattr_init(pthread_rwlockattr_t *);
	extern int pthread_rwlockattr_destroy(pthread_rwlockattr_t *);
	extern int pthread_rwlockattr_getpshared(const pthread_rwlockattr_t * __restrict,int * __restrict);
	extern int pthread_rwlockattr_setpshared(pthread_rwlockattr_t *, int);
#else /* not _PROTOTYPES */
	extern int pthread_rwlockattr_init();
	extern int pthread_rwlockattr_destroy();
	extern int pthread_rwlockattr_getpshared();
	extern int pthread_rwlockattr_setpshared();
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_rwlock_init, pthread_rwlock_destroy
#  pragma extern pthread_rwlock_rdlock, pthread_rwlock_wrlock
#  pragma extern pthread_rwlock_tryrdlock, pthread_rwlock_trywrlock
#  pragma extern pthread_rwlock_unlock
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the read/write mutex functions:			*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_rwlock_init(pthread_rwlock_t * __restrict, 
						const pthread_rwlockattr_t * __restrict);
	extern int pthread_rwlock_destroy(pthread_rwlock_t *);
	extern int pthread_rwlock_rdlock(pthread_rwlock_t *);
	extern int pthread_rwlock_wrlock(pthread_rwlock_t *);
	extern int pthread_rwlock_tryrdlock(pthread_rwlock_t *);
	extern int pthread_rwlock_trywrlock(pthread_rwlock_t *);
	extern int pthread_rwlock_unlock(pthread_rwlock_t *);
#else /* not _PROTOTYPES */
	extern int pthread_rwlock_init();
	extern int pthread_rwlock_destroy();
	extern int pthread_rwlock_rdlock();
	extern int pthread_rwlock_wrlock();
	extern int pthread_rwlock_tryrdlock();
	extern int pthread_rwlock_trywrlock();
	extern int pthread_rwlock_unlock();
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_key_create, pthread_key_delete
#  pragma extern pthread_getspecific, pthread_setspecific
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the thread-specific data functions:			*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_key_create(pthread_key_t *, void (*)(void *));
	extern int pthread_key_delete(pthread_key_t);
	extern void *pthread_getspecific(pthread_key_t);
	extern int pthread_setspecific(pthread_key_t, const void *);
#else /* not _PROTOTYPES */
	extern int pthread_key_create();
	extern int pthread_key_delete();
	extern void* pthread_getspecific();
	extern int pthread_setspecific();
#endif /* _PROTOTYPES */

#ifdef __ia64 
#  pragma extern pthread_cancel, pthread_setcancelstate
#  pragma extern pthread_setcanceltype, pthread_testcancel
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the cancellation functions:				*
 ************************************************************************/
#if defined(_PROTOTYPES) && !defined(PTHREAD_TRACE)
	extern int pthread_cancel(pthread_t);
	extern int pthread_setcancelstate(int, int *);
	extern int pthread_setcanceltype(int, int *);
	extern void pthread_testcancel(void);
#else
	extern int pthread_cancel();
	extern int pthread_setcancelstate();
	extern int pthread_setcanceltype();
	extern void pthread_testcancel();
#endif /* _PROTOTYPES */


#ifdef __ia64 
#  pragma extern pthread_kill, pthread_sigmask
#endif /* __ia64 */ 
/************************************************************************
 * Prototypes for the signal functions:					*
 ************************************************************************/
#ifdef _PROTOTYPES
	extern int pthread_kill(pthread_t, int);
	extern int pthread_sigmask(int, const sigset_t *, sigset_t *);
#else
	extern int pthread_kill();
	extern int pthread_sigmask();
#endif /* _PROTOTYPES */


#ifdef __ia64 
#  pragma extern pthread_suspend, pthread_resume_np, pthread_continue
#  pragma extern pthread_setconcurrency, pthread_getconcurrency
#  pragma extern pthread_num_processors_np, pthread_processor_id_np
#  pragma extern pthread_processor_bind_np, pthread_num_ldoms_np
#  pragma extern pthread_pset_bind_np
#  pragma extern pthread_num_ldomprocs_np, pthread_ldom_id_np
#  pragma extern pthread_spu_to_ldom_np, pthread_ldom_bind_np
#  pragma extern pthread_launch_policy_np, _pthread_getstate_np
#  pragma extern pthread_get_nice_np, pthread_set_nice_np
#  pragma extern pthread_getlwpid_np
#ifdef _INCLUDE_HPUX_SOURCE
#  pragma extern _pthread_stack_info_np, _pthread_callback_np
#endif
#endif /* __ia64 */  
/************************************************************************
 * Prototypes for the extension functions:				*
 ************************************************************************/
#if defined(_PROTOTYPES) && !defined(PTHREAD_TRACE)
	extern int pthread_suspend(pthread_t);
	extern int pthread_resume_np(pthread_t, int);
	extern int pthread_continue(pthread_t);
	extern int pthread_setconcurrency(int);
	extern int pthread_getconcurrency(void);
	extern int pthread_num_processors_np(void);
	extern int pthread_processor_id_np(int, pthread_spu_t *, 
					     pthread_spu_t);
	extern int pthread_processor_bind_np(int, pthread_spu_t *, 
					     pthread_spu_t, pthread_t);
	extern int pthread_pset_bind_np(psetid_t *, psetid_t, pthread_t);
	extern int pthread_num_ldoms_np(void);
	extern int pthread_num_ldomprocs_np(int *, pthread_ldom_t);
	extern int pthread_ldom_id_np(int, pthread_ldom_t *, pthread_ldom_t);
	extern int pthread_spu_to_ldom_np(pthread_spu_t, pthread_ldom_t *);
	extern int pthread_ldom_bind_np(pthread_ldom_t *, pthread_ldom_t,
					pthread_t);
	extern int pthread_launch_policy_np(int, int *, pthread_t);
	extern int _pthread_getstate_np(pthread_t , void *);
	extern int pthread_set_nice_np(pthread_t, int);
	extern int pthread_get_nice_np(pthread_t, int *);
	extern int pthread_getlwpid_np(pthread_t, lwpid_t *);
   #ifdef _INCLUDE_HPUX_SOURCE
	extern int _pthread_stack_info_np(pthread_t id, struct _pthread_stack_info *state);
	extern int _pthread_callback_np(int type, void (*fp)(pthread_t parent, pthread_t child, const _pthread_stack_info_t *stack_info));
   #endif

#else
	extern int pthread_suspend();
	extern int pthread_resume_np();
	extern int pthread_continue();
	extern int pthread_setconcurrency();
	extern int pthread_getconcurrency();
	extern int pthread_num_processors_np();
	extern int pthread_processor_id_np();
	extern int pthread_processor_bind_np();
	extern int pthread_pset_bind_np();
	extern int pthread_num_ldoms_np();
	extern int pthread_num_ldomprocs_np();
	extern int pthread_ldom_id_np();
	extern int pthread_spu_to_ldom_np();
	extern int pthread_ldom_bind_np();
	extern int pthread_launch_policy_np();
	extern int _pthread_getstate_np();
	extern int _pthread_stack_info_np();
	extern int _pthread_callback_np();
	extern int pthread_set_nice_np();
	extern int pthread_get_nice_np();
	extern int pthread_getlwpid_np();
#endif /* _PROTOTYPES */

#ifdef __cplusplus
    }
#endif /* __cplusplus */

#endif /* _SYS_PTHREAD_INCLUDED */
