/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/varargs.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

/* @(#) $Revision: 70.3 $ */
#ifndef _VARARGS_INCLUDED
#define _VARARGS_INCLUDED

/* 
 * This file contains the variable argument macros for both the
 * PA and EM architectures
 */

#if (defined(_PA_RISC1_0) || defined(_PA_RISC1_1) || defined(_PA_RISC2_0))
/* 
 * WARNING: Currently, this is the only way we can detect if we are 
 * compiling for the PA architecture. In the near future, the C Front-End 
 * should generate a macro for this purpose.
 */


/* 
 * Variable argument macros for PA 
 */


#ifndef _SYS_STDSYMS_INCLUDED
#  include <sys/stdsyms.h>
#endif /* _SYS_STDSYMS_INCLUDED */

#ifdef _NAMESPACE_STD
#define _NAMESPACE_STD_START namespace std {
#define _NAMESPACE_STD_END }
#define _hpux_size_t std::size_t
#define __time_t std::time_t
#define __FILE std::FILE
#define __wint_t std::wint_t
#define __struct_tm std::tm
#define __va__list std::va_list
#else
#define _NAMESPACE_STD_START
#define _NAMESPACE_STD_END
#define _hpux_size_t size_t
#define __time_t time_t
#define __FILE FILE
#define __wint_t wint_t
#define __struct_tm struct tm
#define __va__list va_list
#endif

#ifdef __LP64__
#define _ROUNDUP_NEXT_DWORD(byte_size) (((byte_size)+7l)&(~7l))
#define _PREV_DW_ALIGNED_ADDR(address) (((address)&(~7l)))
#endif /* __LP64__ */

#ifdef _STDARG_INCLUDED
#  ifdef _INCLUDE_STDC__SOURCE_199901
#    define va_copy(dest, src) (void)((dest) = (src))
#  endif
#  ifdef __hp9000s300
#    ifndef _VA_LIST
#      define _VA_LIST
       typedef char *va_list;
#    endif  /* _VA_LIST */

#    define va_start(__list,__parmN) __list = (char *) ((char *)(&__parmN) \
	+ sizeof(__parmN))
#    define va_arg(__list,__mode) ((__mode *)(__list += sizeof(__mode)))[-1]
#    define va_end(__list)    (void)0
#  endif /* __hp9000s300 */

#  if defined __hp9000s800 

#  ifdef __lint
#    ifndef _VA_LIST
#      define _VA_LIST
       typedef double *va_list;
#    endif /* _VA_LIST */

#    define va_start(__list,__parmN) __list = (double *) ((double *)(&__parmN)\
	+ sizeof(__parmN))
#    define va_arg(__list,__mode) ((__mode *)(__list += sizeof(__mode)))[-1]
#    define va_end(__list) (void)0
#  else /* ! __lint */

#    define __WORD_MASK 0xFFFFFFFC
#    define __DW_MASK   0xFFFFFFF8

#    ifndef _VA_LIST
#      define _VA_LIST
_NAMESPACE_STD_START
       typedef double *va_list;
_NAMESPACE_STD_END
#    endif /* _VA_LIST */

/* PA32: Args > 8 bytes are passed by reference.  Args > 4 and <= 8 are
 * right-justified in 8 bytes.  Args <= 4 are right-justified in
 * 4 bytes under ILP32.  Args <= 4 are right-justified in
 * 8 bytes under ILP64.  
 */
/* __list is the word-aligned address of the previous argument.
*/
/* If sizeof __mode > 8, address of arg is at __list - 4.  We need to do
 * two indirections:  1 to fetch the address, and 1 to fetch the value.
 * If sizeof __mode <= 8, the word-aligned address of arg is 
 * __list - sizeof __mode, masked to requred alignment (4 or 8 byte).  
 * The real address is the word-aligned address + extra byte offset.
 */
# ifdef __LP64__
#   ifndef __cplusplus
/* PA64: __builtin_va_start need not be called because the PA2.0 calling
   conventions  passes aggregate types in registers and stack. Also
   We first clear the lower most 3 bits of &__parmN, because the 
   first __parmN may be an "int"/"char" or any type < 8 bytes. */

#    define va_start(__list,__parmN)               \
         (__list = (__va__list)(void*) ((char *)(_PREV_DW_ALIGNED_ADDR((long)&__parmN)) + \
		   (_ROUNDUP_NEXT_DWORD(sizeof(__parmN)))))  
#   else /* __cplusplus */                                      
/* This is block of code is for C++ because the above code does not handle 
   references nor special cases where non-PODs passed by value are really 
   passed by a pointer.                                         
*/                                                              
      extern "C" void __builtin_va_start(__va__list *, ...);    
#     define va_start(__list,__parmN) (__builtin_va_start(&__list,&__parmN)) 
#   endif /* __cplusplus */
# else      /* !__LP64__ */
#   if __cplusplus >= 199707    /* This is for aCC */
      extern "C"  {
         void __builtin_va_start(__va__list *, ...);
      }
#     define va_start(__list,__parmN) (__builtin_va_start(&__list,&__parmN))
#   else    /* ! aCC */
#     ifdef __cplusplus
         extern "C" {
            void __builtin_va_start(va_list, ...);
         }
#        define va_start(__list,__parmN)       \
                        (__list=0,__builtin_va_start(__list,&__parmN))
#     else  /* !C++ */

#ifdef __STDC__
         void __builtin_va_start(va_list, ...);
#endif

#if __HP_cc >= 30000 && __HP_cc < 100000
# 	define va_start(__list,__parmN) __builtin_va_start (__list=0,&__parmN)
#else
# 	define va_start(__list,__parmN) __builtin_va_start (__list,&__parmN)
#endif

#     endif /* __cplusplus */
#   endif   /*   aCC       */
# endif     /* __LP64__    */


#ifdef __LP64__
/* PA64 implements the correct calling convention for PA64 
 * Note: in the PA2.0 calling convention  when sizeof(__mode) > 8, 
 *   __list may have to be additionally adjusted by 8 bytes if it is not
 *  already 16 byte aligned. Since __list is guaranteed to be always 
 *  8 byte aligned, we can do this by __list = __list + (__list&8), which 
 *  is what is done below. 
 *  Also: __list has to be incremented by sizeof(__mode) rounded up to the nearest
 *  8 byte aligned address */
#    define va_arg(__list,__mode)	       \
	(sizeof(__mode) > 8l ?		       \
	  (( __list = (__va__list)(void*) ((char *)__list + ((long)__list&(0x8l))  +  \
				 (_ROUNDUP_NEXT_DWORD(sizeof(__mode))))),   \
	   (*((__mode *) ((char *)__list -                                 \
			  (_ROUNDUP_NEXT_DWORD(sizeof(__mode))))))) :       \
	  ((__list = (__va__list)(void*) ((char *)__list + sizeof(char *))),	   \
	   __is_aggregate(__mode) ?                                        \
	     (*((__mode *) ((char *)__list - sizeof(char *)))):            \
	     (*((__mode *) ((char *)__list - sizeof(__mode)))) ))
#else
#    define va_arg(__list,__mode)					\
	(sizeof(__mode) > 8 ?						\
	  ((__list = (__va__list)(void*) ((char *)__list - sizeof (int))),	\
	   (*((__mode *) (*((int *) (__list)))))) :			\
	  ((__list =							\
	      (__va__list)(void*) ((long)((char *)__list - sizeof (__mode))	\
	      & (sizeof(__mode) > 4 ? __DW_MASK : __WORD_MASK))),	\
	   (*((__mode *) ((char *)__list +				\
		((8 - sizeof(__mode)) % 4))))))

#endif /* __LP64__ */

#    define va_end(__list) (void)0

#  endif /* ! __lint */

#  endif /* __hp9000s800 */

#else /* not _STDARG_INCLUDED */

#  if defined __hp9000s800 
#    ifndef _VA_LIST
#      define _VA_LIST
       typedef double *va_list;
#    endif /* _VA_LIST */

#    define va_dcl long va_alist;
#  else
#    ifndef _VA_LIST
#      define _VA_LIST
       typedef char *va_list;
#    endif /* _VA_LIST */

#    define va_dcl int va_alist;
#  endif /* __hp9000s800 */


#  ifdef __hp9000s300
#    define va_start(__list) __list = (char *) &va_alist
#    define va_arg(__list,__mode) ((__mode *)(__list += sizeof(__mode)))[-1]
#  endif /* __hp9000s300 */

#  if defined __hp9000s800 

#  ifdef __lint
#    define va_start(__list) __list = (double *) &va_alist
#    define va_arg(__list,__mode) ((__mode *)(__list += sizeof(__mode)))[-1]
#  else /* ! __lint */

#    define __WORD_MASK 0xFFFFFFFC
#    define __DW_MASK   0xFFFFFFF8


/* Args > 8 bytes are passed by reference.  Args > 4 and <= 8 are
 * right-justified in 8 bytes.  Args <= 4 are right-justified in
 * 4 bytes under ILP32.  Args <= 4 are right-justified in
 * 8 bytes under ILP64.  
 */
/* __list is the word-aligned address of the previous argument.
*/
/* If sizeof __mode > 8, address of arg is at __list - 4.  We need to do
 * two indirections:  1 to fetch the address, and 1 to fetch the value.
 * If sizeof __mode <= 8, the word-aligned address of arg is 
 * __list - sizeof __mode, masked to requred alignment (4 or 8 byte).  
 * The real address is the word-aligned address + extra byte offset.
 */
/* PA64: All that needs to be done is to return the address of va_alist, 
 *   which is the first argument of the variable argument function.
 *  Note: __builtin_va_start needs to be called, because the C front end emits 
 *  an optn 121(indicating that the function has varargs) only when it sees
 *  __builtin_va_start */
#ifdef __STDC__
         void __builtin_va_start(va_list, ...);
#endif
#define va_start(__list) __builtin_va_start (__list, &va_alist)
#ifdef __LP64__

/* PA64 implements the correct calling convention for PA64 */
/* Note: in the PA2.0 calling convention  when sizeof(__mode) > 8, 
 *  __list may have to be additionally adjusted by 8 bytes if it is not
 *  already 16 byte aligned. Since __list is guaranteed to be always 
 * 8 byte aligned, we can do this by __list = __list + (__list&8), which 
 *  is what is done below. 
 *  Also: __list has to be incremented by sizeof(__mode) rounded up to the nearest
 *  8 byte aligned address */
#    define va_arg(__list,__mode)					\
	(sizeof(__mode) > 8l ?						\
	  (( __list = (va_list) (void *) ((char *)__list + ((long)__list&(0x8l))  +  \
	   (_ROUNDUP_NEXT_DWORD(sizeof(__mode))))),	\
	   (*((__mode *) (void *) ((char *)__list -              \
			  (_ROUNDUP_NEXT_DWORD(sizeof(__mode))))))) :    \
	  ((__list = (va_list) (void *) ((char *)__list + sizeof(char *))),	\
	   __is_aggregate(__mode) ?                                     \
	     (*((__mode *) (void *) ((char *)__list - sizeof(char *)))):         \
	     (*((__mode *) (void *) ((char *)__list - sizeof(__mode)))) ))
#else

#    define va_arg(__list,__mode)					\
	(sizeof(__mode) > 8 ?						\
	  ((__list = (va_list) (void *) ((char *)__list - sizeof (int))),	\
	   (*((__mode *) (*((int *) (__list)))))) :			\
	  ((__list =							\
	      (va_list) (void *) ((long)((char *)__list - sizeof (__mode))	\
	      & (sizeof(__mode) > 4 ? __DW_MASK : __WORD_MASK))),	\
	   (*((__mode *) (void *) ((char *)__list +				\
		((8 - sizeof(__mode)) % 4))))))

#endif /* __LP64__ */

#  endif /* __lint */

#  endif /* __hp9000s800 */

#  define va_end(__list) (void)0

#endif /* else _STDARG_INCLUDED */


/* 
 * End Variable argument macros for PA 
 */


#else /* (defined(_PA_RISC1_0) || defined(_PA_RISC1_1) || defined(_PA_RISC2_0))*/


/* 
 * Variable argument macros for EM 
 */

#ifdef _STDARG_INCLUDED

#  ifdef _INCLUDE_STDC__SOURCE_199901
#    define va_copy(dest, src) (void)((dest) = (src))
#  endif

   /* same as VARARGS */
#  ifndef _VA_LIST
#     define _VA_LIST
#     ifdef __lint 
	 typedef double * va_list;
#     else  
#        ifdef _NAMESPACE_STD
            _NAMESPACE_STD_START
            typedef __va_list__ va_list;
            _NAMESPACE_STD_END
#        else
            typedef __va_list__ va_list;
#        endif
#     endif
#  endif /* _VA_LIST */

#  ifdef __lint 
#    define va_start(__list, __parmN) __list= (va_list) ((va_list)(&__parmN) \
	+ sizeof(__parmN))
#  else 
#    define va_start(__list,__parmN) __va_start__(__list)
#  endif 

#else /* not _STDARG_INCLUDED */

#  define va_alist __va_alist__
#  define va_dcl   long __va_alist__;

   /* same as STDARG */
#  ifndef _VA_LIST
#     define _VA_LIST
#     ifdef __lint 
	 typedef double * va_list;
#     else  
         typedef __va_list__ va_list;
#     endif
#  endif /* _VA_LIST */

#  ifdef __lint 
#    define va_start(__list, __parmN) __list= (va_list) ((va_list)(&__parmN) \
	+ sizeof(__parmN))
#  else 
#    define va_start(__list) __va_start__(__list)
#  endif

#endif /* else _STDARG_INCLUDED */

/* same for STDARG and VARARG */

#ifdef __lint 
#  define va_arg(__list,__mode) ((__mode *)(__list += sizeof(__mode)))[-1]
#else
#  define va_arg(__list,__mode)    __va_arg__(__list,__mode)
#endif 

#define va_end(__list) (void)0


/* 
 * End Variable argument macros for EM 
 */


#endif /* (defined(_PA_RISC1_0) || defined(_PA_RISC1_1) || defined(_PA_RISC2_0)) */

#endif /* _VARARGS_INCLUDED */
